<?php

/**
 * @file
 *   Provides the administrative interface changing git documentation in the database.
 */

/**
 * Provide the settings form.
 */
function project_git_instructions_settings_form() {
  $form['project_git_instructions_settings_help'] = array(
    '#value' => '<h3>Example replacement values</h3>
    <div class="codeblock">
    [@project_name] => ctools.git<br />
    [@uri] => ctools<br />
    [%title] => Chaos tool suite<br />
    [@project_fullname] => chaos_tool_suite<br />
    [@branch] => 7.x-1.x<br />
    [@newbranch] => 7.x-2.x<br />
    [@git_username] => user411<br />
    [@uid] => 300411<br />
    [@fullname] => Susan User<br />
    [@email] => => user411@example.org<br />
    [!git_access_link] => <a href="/user/300411/edit/git">Git access page</a><br />
    [@project_username] => merlinofchaos<br />
    [@auth_project_url] => ssh://user411@git.drupal.org:project/ctools.git<br />
    [@anon_project_url] => http://git.drupal.org/project/ctools.git<br />
    [@auth_sandbox_url] => ssh://user411@git.drupal.org:sandbox/merlinofchaos/ctools.git<br />
    [@anon_sandbox_url] => http://git.drupal.org/sandbox/merlinofchaos/ctools.git<br />
    </div>'
  );
  $form['project_git_instructions_maintainer'] = array(
    '#title' => t('Project Maintainer with Branches'),
    '#description' => t('The documentation displayed for a maintainer of an established repository.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_maintainer', project_git_instructions_maintainer()),
  );
  $form['project_git_instructions_nonmaintainer'] = array(
    '#title' => t('Project Non-Maintainer with Branches'),
    '#description' => t('The documentation displayed for a non-maintainer visiting an established repository.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_nonmaintainer', project_git_instructions_nonmaintainer()),
  );
  $form['project_git_instructions_new_maintainer'] = array(
    '#title' => t('Project Maintainer with Empty Repository'),
    '#description' => t('The documentation displayed for a maintainer of an new repository.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_new_maintainer', project_git_instructions_new_maintainer()),
  );
  $form['project_git_instructions_new_nonmaintainer'] = array(
    '#title' => t('Non-Maintainer with Empty Repository'),
    '#description' => t('The documentation displayed to a non-maintainer visiting a project with an empty repository.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_new_nonmaintainer', project_git_instructions_new_nonmaintainer()),
  );
  $form['project_git_instructions_sandbox_maintainer'] = array(
    '#title' => t('Sandbox Maintainer with Branches'),
    '#description' => t('The documentation displayed for a maintainer of an established sandbox repository.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_sandbox_maintainer', project_git_instructions_sandbox_maintainer()),
  );
  $form['project_git_instructions_sandbox_nonmaintainer'] = array(
    '#title' => t('Sandbox Non-Maintainer with Branches'),
    '#description' => t('The documentation displayed for a non-maintainer visiting a sandbox page.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_sandbox_nonmaintainer', project_git_instructions_sandbox_nonmaintainer()),
  );
  $form['project_git_instructions_sandbox_new_maintainer'] = array(
    '#title' => t('Sandbox Maintainer with Empty Repository'),
    '#description' => t('The documentation displayed for a maintainer of a new sandbox repository.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_sandbox_new_maintainer', project_git_instructions_sandbox_new_maintainer()),
  );
  $form['project_git_instructions_repository_not_yet_created'] = array(
    '#title' => t('Repository Missing'),
    '#description' => t('The documentation displayed for the short time between project creation and repository creation.'),
    '#type' => 'textarea',
    '#rows' => 20,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_repository_not_yet_created', project_git_instructions_repository_not_yet_created()),
  );
  $form['project_git_instructions_empty_git_username'] = array(
    '#title' => t('Maintainer Without Git Username'),
    '#description' => t('Shown instead of instructions when a maintainer has not set a git username.'),
    '#type' => 'textarea',
    '#rows' => 5,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_empty_git_username', project_git_instructions_empty_git_username()),
  );
  $form['project_git_instructions_project_promoted'] = array(
    '#title' => t('Project Promoted'),
    '#description' => t('The documentation displayed as a drupal_set_message() after a project is promoted.'),
    '#type' => 'textarea',
    '#rows' => 10,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_project_promoted', project_git_instructions_project_promoted()),
  );
  $form['project_git_instructions_clone_url_direction'] = array(
    '#title' => t('Sandbox Clone URL'),
    '#description' => t('One line displayed to non-maintainers on sandbox project pages for easy copy and paste cloning.'),
    '#type' => 'textarea',
    '#rows' => 1,
    '#cols' => 80,
    '#default_value' => variable_get('project_git_instructions_clone_url_direction', project_git_instructions_clone_url_direction()),
  );
  $form['project_git_instructions_git_repository_url_authenticated'] = array(
    '#title' => t('Repository URL for Authenticated Users'),
    '#description' => t('The preferred URL style. You can use variables here.'),
    '#type' => 'textfield',
    '#default_value' => variable_get('project_git_instructions_git_repository_url_authenticated', '@git_username@git.drupal.org:project/@project_name'),
  );
  $form['project_git_instructions_git_repository_url_anonymous'] = array(
    '#title' => t('Repository URL for Anonymous Users'),
    '#description' => t('The preferred URL style. You can use variables here.'),
    '#type' => 'textfield',
    '#default_value' => variable_get('project_git_instructions_git_repository_url_anonymous', 'http://git.drupal.org/project/@project_name'),
  );
  $form['project_git_instructions_git_sandbox_repository_url_authenticated'] = array(
    '#title' => t('Repository URL for Authenticated Users (Sandbox)'),
    '#description' => t('The preferred URL style. You can use variables here.'),
    '#type' => 'textfield',
    '#default_value' => variable_get('project_git_instructions_git_sandbox_repository_url_authenticated', '@git_username@git.drupal.org:sandbox/@project_username/@project_name'),
  );
  $form['project_git_instructions_git_sandbox_repository_url_anonymous'] = array(
    '#title' => t('Repository URL for Anonymous Users (Sandbox)'),
    '#description' => t('The preferred URL style. You can use variables here.'),
    '#type' => 'textfield',
    '#default_value' => variable_get('project_git_instructions_git_sandbox_repository_url_anonymous', 'http://git.drupal.org/sandbox/@project_username/@project_name'),
  );

  return system_settings_form($form);
}
